--- old/usr/src/lib/libc/port/locale/setrunelocale.c	2013-06-16 17:44:38.073848409 +0000
+++ new/usr/src/lib/libc/port/locale/setrunelocale.c	2013-06-16 17:44:38.088368676 +0000
@@ -6,6 +6,11 @@
  * This code is derived from software contributed to Berkeley by
  * Paul Borman at Krystal Technologies.
  *
+ * Copyright (c) 2011 The FreeBSD Foundation
+ * All rights reserved.
+ * Portions of this software were developed by David Chisnall
+ * under sponsorship from the FreeBSD Foundation.
+ *
  * Redistribution and use in source and binary forms, with or without
  * modification, are permitted provided that the following conditions
  * are met:
@@ -47,6 +52,11 @@
 #include "_ctype.h"
 #include "../i18n/_locale.h"
 
+/*
+ * A cached version of the runes for this thread.  Used by ctype.h
+ */
+__thread const _RuneLocale *_ThreadRuneLocale;
+
 extern _RuneLocale	*_Read_RuneMagi(FILE *);
 extern unsigned char	__ctype_C[];
 
@@ -250,3 +260,25 @@
 	}
 	return (_LDP_LOADED);
 }
+
+void
+__set_thread_rune_locale(locale_t loc)
+{
+
+	if (loc == NULL) {
+		_ThreadRuneLocale = &_DefaultRuneLocale;
+	} else {
+		_ThreadRuneLocale = XLOCALE_CTYPE(loc)->runes;
+	}
+}
+
+void *
+__ctype_load(const char *locale, locale_t unused)
+{
+	struct xlocale_ctype *l;
+
+	l = calloc(sizeof(struct xlocale_ctype), 1);
+	/* XXX */
+
+	return (l);
+}
